package td02;

public class Point2DCartesien{

	private double x;
	private double y;

	public Point2DCartesien(double x, double y){
		this.x = x;
		this.y = y;
	}

	public Point2DCartesien(Point2DCartesien p){
		this(p.x, p.y);
	}

	public double getAbscisse(){
		return this.x;
	}

	public double getOrdonnee(){
		return this.y;
	}

	public void setAbscisse(double x){
		this.x = x;
	}

	public void setOrdonnee(double y){
		this.y = y;
	}

	public Point2DCartesien clone(){
		return new Point2DCartesien(x, y);
	}

	public void translate(double dx, double dy) {
		x += dx;
		y += dy;
	}

	public double module(){
		return Math.sqrt(this.x*this.x+this.y*this.y);
	}

	public double argument(){
		return Math.atan2(this.y,this.x);
	}

	public void homothetie(double rapport){
		this.x *= rapport;
		this.y *= rapport;
	}

	public void rotation(double angle){
		double abs = Math.cos(angle)*this.x - Math.sin(angle)*this.y;
		double ord = Math.sin(angle)*this.x + Math.cos(angle)*this.y;
		this.x = abs;
		this.y = ord;
	}

	public static double distance(Point2DCartesien p1, Point2DCartesien p2){
		double abs = p2.getAbscisse()-p1.getAbscisse();
		double ord = p2.getOrdonnee()-p1.getOrdonnee();
		return Math.sqrt(abs*abs+ord*ord);
	}

	public boolean equals(Point2DCartesien p){
		return this.x == p.x && this.y == p.y;
	}

	public String toString(){
		return "(" + x + "," + y + ")";
	}
}
