package td02;

public class PolygonePoint2DCartesien {

	private Point2DCartesien[] copierTabPoints(Point2DCartesien[] points){
		Point2DCartesien[] copie = new Point2DCartesien[points.length];
		for(int i=0; i<points.length; i++)
			copie[i]= points[i].clone();
		return copie;
	}


	public PolygonePoint2DCartesien(Point2DCartesien[] points){
		this.sommets= copierTabPoints(points);
	}

	public Point2DCartesien[] getSommets(){
		return copierTabPoints(this.sommets);
	}    

	public double perimetre(){
		int n = sommets.length;
		double pmtr= Point2DCartesien.distance(this.sommets[0],this.sommets[n-1]);
		for(int i=0; i<n-1; i++){
			pmtr+= Point2DCartesien.distance(this.sommets[i], this.sommets[i+1]);
		}
		return pmtr;
	}
	public void homothetie(double rapport){
		for(int i=0; i<sommets.length; i++){
			this.sommets[i].homothetie(rapport);
		}
	}
	public void rotation(double angle){
		for(int i=0; i<sommets.length; i++){
			this.sommets[i].rotation(angle);
		}
	}

	public boolean equals(PolygonePoint2DCartesien poly) {
		if (sommets.length != poly.sommets.length)
			return false;
		for(int i=0; i<sommets.length; i++){
			if(!this.sommets[i].equals(poly.sommets[i]))
				return false;
		}
		return true;
	}

	public String toString(){
		StringBuffer s= new StringBuffer();
		s.append("PolygonePoint2DCartesien(\n");
		for(int i=0; i<sommets.length - 1; i++){
			s.append(this.sommets[i]+",\n");
		}
		s.append(this.sommets[sommets.length - 1]+")");
		return new String(s);
	}

	public Point2DCartesien geoCentre(){
		double x=0;
		double y=0;
		for(int i=0; i<sommets.length; i++){
			x+= this.sommets[i].getAbscisse();
			y+= this.sommets[i].getOrdonnee();
		}
		return new Point2DCartesien(x/sommets.length,y/sommets.length);
	}

	public Rectangle boiteEnglobante(){
		double xMin= this.sommets[0].getAbscisse();
		double xMax= xMin;
		double yMin= this.sommets[0].getOrdonnee();
		double yMax= yMin;
		for(int i=1; i<sommets.length; i++){
			if(xMin > this.sommets[i].getAbscisse()){
				xMin= this.sommets[i].getAbscisse();
			}
			else 
				if(xMax < this.sommets[i].getAbscisse()){
					xMax= this.sommets[i].getAbscisse();
				}
			if(yMin > this.sommets[i].getOrdonnee()){
				yMin= this.sommets[i].getOrdonnee();
			}
			else 
				if(yMax < this.sommets[i].getOrdonnee()){
					yMax= this.sommets[i].getOrdonnee();
				}
		}
		return new Rectangle(new Point2DCartesien(xMin, yMin),
				new Point2DCartesien(xMax, yMax));
	}

	private Point2DCartesien[] sommets;
}
