package td02;

public class Relation{

	public Relation(boolean[][] tRelation){
		int n = tRelation.length;
		relation = new boolean[n][n];
		for(int i=0; i<n; ++i)
			for(int j=0; j<n; ++j)
				relation[i][j] = tRelation[i][j];
	}

	public boolean estEnRelation(int i, int j){
		return relation[i][j];
	}

	public boolean reflexive(){
		for(int i=0; i<relation.length; ++i)
			if (!estEnRelation(i, i))
				return false;
		return true;
	}

	public boolean symetrique(){
		for(int i=1; i<relation.length; ++i)
			for(int j=0; j<i; ++j)
				if (estEnRelation(i, j)!= estEnRelation(j, i))
					return false;
		return true;
	}

	public boolean transitive(){
		int n = relation.length;
		for(int i=0; i<n; ++i)
			for(int j=0 ; j<n; ++j) 
				if (estEnRelation(i, j))
					for(int k=0; k<n; ++k)
						if (estEnRelation(j, k) && !estEnRelation(i, k))
							return false;
		return true;
	}

	public static Relation composee(Relation r1, Relation r2){
		int n = r1.relation.length;
		boolean[][] composee = new boolean[n][n];
		for(int i=0; i<n; ++i)
			for(int j=0 ; j < n ; ++j)
				if (r1.estEnRelation(i, j))
					for(int k=0; k < n; ++k)
						if(r2.estEnRelation(j, k))
							composee[i][k]= true;
		return new Relation(composee);
	}

	public int[] image(int i){
		// on détermine la taille de l'image
		int taille=0;
		int n = relation.length;
		for( int j=0; j < n; ++j)
			if(estEnRelation(i, j))
				taille++;
		int tableImage[] = new int[taille];
		for( int j=0,k=0; j < n; ++j)
			if(estEnRelation(i, j))
				tableImage[k++]=j;
		return tableImage;
	}

	private boolean[][] relation;

}
