package td02;

public class TestRelation{
	private static final int N = 11;

	private static void resultatTest(boolean condition,String nomMethode){
		if (condition)
			System.out.println("Test " + nomMethode + " passe avec succes");
		else
			System.out.println("Erreur test "+ nomMethode);
	}

	public static void main(String[] arg){

		boolean[][] tMultipleDe = new boolean[N][N];
		tMultipleDe[0][0] = true;
		for (int i=1; i<N; ++i){
			tMultipleDe[i][0] = false;
			for (int j=1; j<N; ++j)
				tMultipleDe[i][j] = (i%j==0);
		}

		Relation multipleDe = new Relation(tMultipleDe);

		boolean[][] tCongruModulo2 = new boolean[N][N];
		for (int i=0; i<N ; ++i)
			for (int j =0; j<N ; ++j)
				tCongruModulo2[i][j] = ((i-j)%2==0);
		Relation congruModulo2 = new Relation(tCongruModulo2);

		boolean[][] tStrictementInferieur = new boolean[N][N];
		for (int i=0; i<N ; ++i)
			for (int j =0; j<N ; ++j)
				tStrictementInferieur[i][j] = (i<j);
		Relation strictementInferieur = new Relation(tStrictementInferieur);

		boolean[][] tPlus2OuMoins3 = new boolean[N][N];
		for (int i=0; i<N ; ++i)
			for (int j=0; j<N ; ++j)
				if ( j==i+2 || j==i-3 )
					tPlus2OuMoins3[i][j] = true;
		Relation plus2OuMoins3 = new Relation(tPlus2OuMoins3);

		resultatTest (multipleDe.reflexive() &&
				congruModulo2.reflexive()&& 
				!strictementInferieur.reflexive() &&
				!plus2OuMoins3.reflexive() , "reflexive");

		resultatTest (!multipleDe.symetrique() &&
				congruModulo2.symetrique()&& 
				!strictementInferieur.symetrique() &&
				!plus2OuMoins3.symetrique() , "symetrique");

		resultatTest (multipleDe.transitive() &&
				congruModulo2.transitive()&& 
				strictementInferieur.transitive() &&
				!plus2OuMoins3.transitive() , "transitive");


		Relation composee = Relation.composee(plus2OuMoins3,plus2OuMoins3);
		boolean comp = true;

		for(int i=0; i<N; ++i)
			for(int j=0; j<N; ++j)
				if (j==i+4 || j==i-1 || j==i-6){
					if (!composee.estEnRelation(i, j))
						comp = false;
				}
				else
					if (composee.estEnRelation(i, j))
						comp = false;
		resultatTest(comp,"composee");


		int[] image = composee.image(6);
		resultatTest (image.length == 3 && image[0] == 0 &&
				image[1] == 5 && image[2] == 10 ,"image");

	}
}
